﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using System.Web.Http.OData;
using System.Web.Http.OData.Query;

namespace test_mvc_sf_ng.Controllers
{
    public class AppController : ApiController
    {
        private Models.InMemDb _db = null;

        public AppController(Models.InMemDb db)
        {
            _db = db;
        }

        public PageResult<Models.Element> Get(ODataQueryOptions<Models.Element> query)
        {
            if (query.SelectExpand?.SelectExpandClause?.SelectedItems?.Any() ?? false)
            {
                return new PageResult<Models.Element>(Enumerable.Empty<Models.Element>(), null, 0);
            }

            var data = _db.Data.AsQueryable();

            var result = (query.ApplyTo(data) as IQueryable<Models.Element>).ToList();
            var count = query.InlineCount.Value == InlineCountValue.AllPages ? _db.Data.Count : query.InlineCount.GetEntityCount(data);

            return new PageResult<Models.Element>(result, null, count);
        }

        public void Post(Models.Element e)
        {
            if (e != null)
            {
                e.Id = _db.Data.Count + 1;
                _db.Data.Add(e);
            }
        }

        public void Put(Models.Element e)
        {
            if (e != null)
            {
                var el = _db.Data.SingleOrDefault(d => d.Id == e.Id);
                if (el != null)
                {
                    el.Name = e.Name;
                }
            }
        }

        public void Delete(int id)
        {
            var el = _db.Data.SingleOrDefault(d => d.Id == id);
            if (el != null)
            {
                _db.Data.Remove(el);
            }
        }
    }
}
